#Passi per rendere persistente la configurazione di keycloak

# Il comando originale per far partire keycloak
docker run -p 8080:8080 -e KC_BOOTSTRAP_ADMIN_USERNAME=admin -e KC_BOOTSTRAP_ADMIN_PASSWORD=admin quay.io/keycloak/keycloak:26.1.2 start-dev

# Crea un volume Docker per Keycloak
docker volume create keycloak_data

# Copia i dati dal container attuale nella directory corrente, fa il backup
docker cp <container_id>:/opt/keycloak/data ./keycloak-data-backup

# Ora monta il volume al container temporaneo per copiare i dati dal backup al volume keycloak_data
docker run --rm -v keycloak_data:/mnt/keycloak-data -v $(pwd)/keycloak-data-backup:/backup ubuntu bash -c "cp -r /backup/* /mnt/keycloak-data/"

# Aggiustare l'ownership del volume da montare
chown 1000 /var/lib/docker/volumes/keycloak_data/_data -R

# Il comando per far partire in detach keycloak con montato il named volume keycloak_data
docker run -d -p 8080:8080 \
  -e KC_BOOTSTRAP_ADMIN_USERNAME=admin \
  -e KC_BOOTSTRAP_ADMIN_PASSWORD=admin \
  -v keycloak_data:/opt/keycloak/data \
  quay.io/keycloak/keycloak:26.1.2 start-dev


